function cracknich(handles)
%Metodo de Crank-Nicolson
%Metodo de crank-nicoloson
%La matriz W contiene los resultados del metodo. Las columnas corresponden
%a la variacion en el tiempo, y las filas a la variacion en x.
% close all
%Entrada de datos
Preguntas={'Longitud de la barra: '
'Limite de Tiempo'
'Numero de particiones en el tiempo'
'Numero de particiones en x'
'Coeficiente alfa'
'Funcion de temperatura inicial'};
Titulo = 'Entrada de Datos (Metodo de diferencias progresivas)';
Defecto = {'1', '0.40' , '40' , '10' , '1' , 'sin(pi*x)'};
datos=inputdlg(Preguntas, Titulo, 1, Defecto);
L=str2num(datos{1});
T=str2num(datos{2});
N=str2num(datos{3});
m=str2num(datos{4});
alfa=str2num(datos{5});
f=datos{6};
%Incializacion
h=L/m;
k=T/N;

lambda=alfa^2*k/h^2;
v(m,1)=0;
W=[];
x=sym('x');
%Obtencion de los resultados
for(i=1:m-1)
x=i*h;
v(i,1)=eval(f);
end
%v(1:m-1,1)=(subs(f,(1:m-1)*h))';
W=[W;v'];
l(1,1)=1+lambda;
u(1,1)=-lambda/(2*l(1,1));
for i=2:m-2
l(i,1)=1+lambda+lambda*u(i-1,1)/2;
u(i,1)=-lambda/(2*l(i,1));
end
l(m-1,1)=1+lambda+lambda*u(m-2,1)/2;
for j=1:N
t=j*k;
z(1,1)=((1-lambda)*v(1,1)+lambda/2*v(2,1))/l(1,1);
for i=2:m-1
z(i,1)=((1-lambda)*v(i,1)+lambda/2*(v(i+1,1)+v(i-1,1)+z(i-1,1)))/l(i,1);
end
v(m-1,1)=z(m-1,1);
for i=m-2:-1:1
v(i,1)=z(i,1)-u(i,1)*v(i+1,1);
end
W=[W;v'];
end
%Graficacion de la solucion
num_rows=size(W,1);
zeros_col=zeros(num_rows,1);
W=[zeros_col W];
 axes(handles.axes1)
 hold on
plot(W(1,:));
limites=axis
maximo=limites(4);
for(a=2:size(W,1))
plot(W(a,:))
limites=[1 m+1 0 maximo];
axis(limites);
pause(0.01)
end
title('Temperatura vs. x')
ylabel('u(x)')
xlabel('x')
hold off

 axes(handles.axes2)
mesh(W)
title('Superficie de Distribucion de Temperatura')
ylabel('t')
xlabel('x')
zlabel('u(x,t)')
shading interp

W;