function difregresivas(handles)
%Metodo de diferencias regresivas. W contiene la matriz con la solucion
%La matriz W contiene los resultados del metodo. Las columnas corresponden
%a la variacion en el tiempo, y las filas a la variacion en x.
% close all
% clear all
% clc
%Entrada de datos
Preguntas={'Longitud de la barra: '
'Limite de Tiempo'
'Numero de particiones en el tiempo'
'Numero de particiones en x'
'Coeficiente alfa'
'Funcion de temperatura inicial'};
Titulo = 'Entrada de Datos (Metodo de diferencias Regresivas)';
Defecto = {'1', '0.40' , '40' , '10' , '1' , 'sin(pi*x)'};
datos=inputdlg(Preguntas, Titulo, 1, Defecto);

l=str2num(datos{1});
T=str2num(datos{2});
N=str2num(datos{3});
m=str2num(datos{4});
alpha=str2num(datos{5});
f=datos{6};
x=sym('x');
%Inicializacion
h=l/m;
k=T/N;
lambda=((alpha^2)*k)/h^2;
W=[];
w=[];
%Obtencion de la solucion
for(i=1:m-1)
x=i*h;
w(1,i)=eval(f);
end
W=[W;w];
L=[];
u=[];
L(1)=1+2*lambda;
u(1)=-lambda/L(1);
for(i=2:m-2)
L(i)=1 + 2*lambda + lambda*u(i-1);
u(i)=-lambda/L(i);
end
L(m-1)=1 + 2*lambda + lambda*u(m-2);
for(j=1:N)
t=j*k;
z=[];
z(1)=w(1)/L(1);
for(i=2:m-1)
z(i)=(w(i) + lambda*z(i-1))/L(i);
end
w(m-1)=z(m-1);
for(i=m-2:-1:1)
w(i)=z(i) - u(i)*w(i+1);
end
W=[W;w];
end
%Grafica da la solucion
num_rows=size(W,1);
zeros_col=zeros(num_rows,1);
W=[zeros_col W zeros_col];
 axes(handles.axes1)
plot(W(1,:));

limites=axis;
maximo=limites(4);
hold on
for(a=2:size(W,1))
plot(W(a,:))
limites=[1 m+1 0 maximo];
axis(limites);
pause(0.01)
end
title('Temperatura vs. x')
ylabel('u(x)')
xlabel('x')
hold off
axes(handles.axes2)
mesh(W)
title('Superficie de Distribucion de Temperatura')
ylabel('t')
xlabel('x')
zlabel('u(x,t)')
shading interp